
// set giu mode to auto by default
document.plugInfo = {dark: 0};

var chartMustRedraw = false;

function OnArbitraryMessage(msgTag, msgVal) {
  msgVal = atob(msgVal);
  switch (msgTag) {
    case -2:
      document.plugInfo = JSON.parse(msgVal);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.version}", document.plugInfo.version);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.buildDate}", document.plugInfo.buildDate);
      document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace("{plugInfo.copyright}", document.plugInfo.copyright);
      
      // remove purchase buttons if plug is purchased
      if(document.plugInfo.purchased) {
        document.getElementById("purchase-buttons").innerHTML = "";
      } else {
        
        document.getElementById("purchase-btn").addEventListener('click', function(event){
          SAMFUI(66,-1,"{}");
        });
        document.getElementById("restore-btn").addEventListener('click', function(event){
          SAMFUI(67,-1,"{}");
        });
        setTimeout(function(){
          let aboutModal = new bootstrap.Modal(document.getElementById('aboutModal'), {});
          aboutModal.show();
        }, 500);
      }
      
      var elements = document.getElementsByClassName("track-name");
      Array.from(elements).forEach((el) => {
        el.innerHTML = document.plugInfo.trackname;
        if(document.plugInfo.trackname == "") {
          el.innerHTML = "Track with no name";
        }
      });
      
      handleUIModeChange(document.plugInfo.dark);
      
      break;
      
      // ios app purchased
      case -3:
        document.plugInfo.purchase = JSON.parse(msgVal);
        document.getElementById("purchase-buttons").innerHTML = "";
        document.getElementById("aboutModal").innerHTML = document.getElementById("aboutModal").innerHTML.replace(" DEMO", "");
        if(document.plugInfo.purchase.restored == 1) {
          document.getElementById("purchase-buttons").innerHTML = "<h2 class=\"text-success\">Purchase restored</h2>";
        }
        break;
      
      // presets
      case 200:
         var userPresets = JSON.parse(msgVal);
         
         var presets = document.getElementById("presets");
         presets.innerHTML = "<option disabled><b>Factory Presets</b></option>";
         document.plugInfo.factoryPresets.forEach((preset) => {
             var option = document.createElement("option");
             option.value = preset;
             option.classList.add("factory-preset");
             option.innerHTML = preset;
             presets.appendChild(option);
         });
         var option = document.createElement("option");
         option.disabled = true;
         option.innerHTML = "<b>User Presets</b>";
         presets.appendChild(option);
         userPresets.forEach((preset) => {
             var option = document.createElement("option");
             option.value = preset;
             option.classList.add("user-preset");
             option.innerHTML = preset;
             presets.appendChild(option);
         });
         presets.addEventListener("change", (event) => {
             if(event.target.selectedOptions[0].className == "factory-preset") {
                 SAMFUI(100, ctrlTag = -1, event.target.value);
                 document.querySelector("#loadPresetModal .btn-close").dispatchEvent(new Event("click"));
             } else {
                 SAMFUI(101, ctrlTag = -1, event.target.value);
                 document.querySelector("#loadPresetModal .btn-close").dispatchEvent(new Event("click"));
             }
             console.log(event.target);
         });
       break;
     
    // update freq dispaly
    case 90:
      let data = JSON.parse(msgVal);
      for(var i = 0; i < data["in"].length; i++) {
        if(typeof document.freqChart.data.datasets[0].data[i] !== 'undefined') {
            
            if(data["in"][i] > document.freqChart.data.datasets[0].data[i].y) {
                document.freqChart.data.datasets[0].data[i] = {"x":data["freqs"][i], "y":data["in"][i]};
            }
            if(data["out"][i] > document.freqChart.data.datasets[1].data[i].y) {
                document.freqChart.data.datasets[1].data[i] = {"x":data["freqs"][i], "y":data["out"][i]};
            }
            document.freqChart.data.datasets[2].data[i] =  {"x":data["freqs"][i], "y":data["eq"][i]};
        } else {
            document.freqChart.data.datasets[0].data[i] =  {"x":data["freqs"][i], "y":data["in"][i]};
            document.freqChart.data.datasets[1].data[i] =  {"x":data["freqs"][i], "y":data["out"][i]};
            document.freqChart.data.datasets[2].data[i] =  {"x":data["freqs"][i], "y":data["eq"][i]};
        }
        if(data["freqs"][i] < Number(document.getElementById("low-limit").value)
           || data["freqs"][i] > Number(document.getElementById("up-limit").value)) {
          document.freqChart.data.datasets[2].data[i].y = 0;
        }
      }
      
      // update bars to limit EQ view
      document.freqChart.data.datasets[3].data[0].x = Number(document.getElementById("low-limit").value);
      document.freqChart.data.datasets[3].data[1].x = Number(document.getElementById("low-limit").value);
      document.freqChart.data.datasets[4].data[0].x = Number(document.getElementById("up-limit").value);
      document.freqChart.data.datasets[4].data[1].x = Number(document.getElementById("up-limit").value);
      
      if (data["complete"]==false) {
        document.getElementsByClassName("spectrum-view")[0].classList.add("analysis");
      } else {
        document.getElementsByClassName("spectrum-view")[0].classList.remove("analysis");
      }
      chartMustRedraw = true;
      //updateChart();
      break;
    
  }
}

function handleUIModeChange(mode) {
  // set dark mode according to preferences
  if(mode == 1) {
    // light  or dark mode
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', 'light');
  } else if (mode == 2) {
    // dark mode
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', 'dark');
  } else if (mode == 0) {
    // auto mode
    const media = window.matchMedia('(prefers-color-scheme: dark)');
    const scheme = media.matches
      ? 'dark'
      : 'light'
    document.getElementsByTagName('html')[0].setAttribute('data-bs-theme', scheme);
  }
  document.freqChart.options.scales.xAxes[0].gridLines.color = window.getComputedStyle(document.body).getPropertyValue('--bs-secondary-bg');
  document.freqChart.options.scales.yAxes[0].gridLines.color = window.getComputedStyle(document.body).getPropertyValue('--bs-secondary-bg');

}


addEventListener('ControlSetup', (event) => {

  addEventListener('ControlChange', (event)=> {
    GetControlByMessageId(event.detail.tag).forEach(function(elem){
      elem.setValue(event.detail.value);
    });
  });
  
  // reset button start over audio analisys
  document.getElementById("reset-btn").addEventListener('click', function(event){
    document.getElementById("filters-view").classList.toggle("active");
    document.getElementById("controls-view").classList.toggle("active");
    document.getElementsByClassName("nav-link")[0].classList.toggle("active");
    document.getElementsByClassName("nav-link")[1].classList.toggle("active");
    SAMFUI(1000, -1, "{}");
  });
  
  // save original ui proportions
  document.uiratio = document.documentElement.clientWidth / document.documentElement.clientHeight;
  document.uiminwidth = document.documentElement.clientWidth / 2;
  document.uimaxwidth = document.documentElement.clientWidth * 2;
  
  // attach window resizer
  var isIOS = navigator.userAgent.includes("iOS");
  if(!isIOS) {
    var resizeCtrl = document.createElement('div');
    resizeCtrl.style.cssText = "position:absolute;right:0px;bottom:0px;width:48px;height:48px;border-bottom:8px solid rgb(255,205,67);border-right:8px solid rgb(255,205,67);";
    resizeCtrl.style
    function dragResize(event) {
      var msg = {};
      msg.x = event.clientX;
      if(window.navigator.platform.indexOf("Win") >= 0) {
        msg.x *= window.devicePixelRatio;
      }
      if(msg.x < document.uiminwidth) msg.x = document.uiminwidth;
      if(msg.x > document.uimaxwidth) msg.x = document.uimaxwidth;
      msg.y = msg.x/document.uiratio;
      SAMFUI(-99, -1, JSON.stringify(msg));
    }
    
    resizeCtrl.addEventListener("mousedown", function(event){
      window.addEventListener("mousemove", dragResize);
    });
    window.addEventListener("mouseup", function(event) {
      window.removeEventListener("mousemove", dragResize);
    });
    resizeCtrl.addEventListener("mouseover", function(event){
      event.target.style.cursor = "nwse-resize";
    });
    resizeCtrl.addEventListener("mouseout", function(event){
      event.target.style.cursor = "initial";
    });
    document.body.appendChild(resizeCtrl);
    
  }
    
  // save preset action
  document.getElementById('savePresetModalOk').addEventListener('click', (event)=> {
    SAMFUI(102,-1,document.getElementById('presetName').value);
  });

  // handle color theme change from dark to light
  const media = window.matchMedia("(prefers-color-scheme: dark)");
  media.addListener(function(){
    handleUIModeChange(document.plugInfo.dark);
  });
  
  document.pauseSpectrum = false;
  document.getElementById("spectrum-view").addEventListener('click', function(evt){
    document.pauseSpectrum = !document.pauseSpectrum;
  });
  function updateChart(){
    
    //document.freqChart.options.scales.xAxes[0].ticks.fontSize = parseInt(getComputedStyle(document.body).fontSize);
    //document.freqChart.options.scales.yAxes[0].ticks.fontSize = parseInt(getComputedStyle(document.body).fontSize);
    //document.freqChart.options.scales.yAxes[1].ticks.fontSize = parseInt(getComputedStyle(document.body).fontSize);
    if(chartMustRedraw == true && document.pauseSpectrum == false) {
      
      document.freqChart.update();
      for (var i =0; i < document.freqChart.data.datasets[0].data.length; i++) {
        document.freqChart.data.datasets[0].data[i].y -=1;
        document.freqChart.data.datasets[1].data[i].y -=1;
      }
      
      chartMustRedraw = false;
    }
    requestAnimationFrame(updateChart.bind(this));
  }
  updateChart();

  //setInterval(, 42);
  
  // resize ui if the monitor is too small
  if(screen.height < 900) {
    var msg = {};
    msg.x = 800;
    msg.y = 600;
    SAMFUI(-99, -1, JSON.stringify(msg));
  }
  
});

document.getElementById('aboutModal').addEventListener('shown.bs.modal', function () {
  
  // set mode droptown to current value
  document.getElementById("dark").value = document.plugInfo.dark;
  
  function updatePreferences() {

    // Create an object to hold the name/value pairs
    const pairs = {
      dark: document.getElementById("dark").value,
    };
    // Return the JSON string
    SAMFUI(999,-1,JSON.stringify(pairs));
  }
  
  // listen color mode change from preferences ui
  document.getElementById("dark").addEventListener("change", function() {
    handleUIModeChange(this.value);
    updatePreferences();
  });
});
